<template>
  <v-row>
    <!-- manifest -->
    <v-col :cols="12">
      <v-card>
        <v-card-title
          >{{ getAppName }}
          <span style="color:gray; font-size: 0.7em; margin-left: 10px">{{
            getPackageName
          }}</span>
          <v-spacer />
          <v-btn icon @click="showManifest = !showManifest">
            <v-icon>{{
              showManifest ? "mdi-chevron-up" : "mdi-chevron-down"
            }}</v-icon>
          </v-btn>
        </v-card-title>
        <v-expand-transition>
          <v-card-text v-show="showManifest">
            <vue-json-pretty :data="manifest"></vue-json-pretty>
          </v-card-text>
        </v-expand-transition>
      </v-card>
    </v-col>
    <v-col v-for="(value, i) in [0, 1, 2, 3]" :key="i" :lg="3" :sm="12" :cols="12">
      <circle-statistic-card-without-caption
        :title="chartData.labels[i]"
        :icon="chartData.datasets[0].icon[i]"
        :color="chartData.datasets[0].borderColor[i]"
        :value="chartData.datasets[0].data[i]"
      />
    </v-col>

    <v-col cols="12">
      <v-card>
        <!-- search bar -->
        <v-card-title>
          <v-text-field
            v-model="search"
            append-icon="mdi-magnify"
            label="Search"
            single-line
            hide-details
          ></v-text-field>
        </v-card-title>

        <!-- log table -->
        <v-data-table
          :headers="headers"
          :items="logdata"
          :items-per-page="150"
          :search="search"
          :footer-props="{
            itemsPerPageOptions: [150, 300, 500, 1000, -1]
          }"
          multi-sort
          dense
          show-expand
          :expanded.sync="expanded"
        >
          <template v-slot:[`item.pattern_category`]="{ item }">
            <v-chip
              :color="getColor(item.pattern_category)"
              v-if="item.pattern_category !== null"
              dark
            >
              {{ item.pattern_category }}
            </v-chip>
          </template>

          <template v-slot:expanded-item="{ headers, item }">
            <td
              v-if="item.payload !== null || item.payload !== undefined"
              :colspan="headers.length"
            >
              {{ item.payload }}
            </td>
          </template>

          <v-data-footer :items-per-page-options="[150, 300, 500, 1000]" />
        </v-data-table>

        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn text class="mr-3" color="primary" @click="stopAnalyze()">
            STOP ANALYZE
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-col>
  </v-row>
</template>

<script>
import logcat from "@/service/logcat";
import manifest from "@/service/manifest";
import session from "@/service/session";
import VueJsonPretty from "vue-json-pretty";
import Util from "@/util"; 
import CircleStatisticCardWithoutCaption from "../components/card/CircleStatisticCardWithoutCaption.vue";

export default {
  components: {
    VueJsonPretty,
    CircleStatisticCardWithoutCaption
  },
  data() {
    return {
      expanded: [],
      singleExpand: false,
      chartData: {
        labels: ["DISCOVERY", "ATTACK", "HIDING", "NETWORK"],
        datasets: [
          {
            data: [0, 0, 0],
            icon: ["mdi-magnify", "mdi-spider", "mdi-eye-off", "mdi-web"],
            backgroundColor: [
              "rgba(76, 175, 80, 0.2)",
              "rgba(255, 99, 132, 0.2)",
              "rgba(255, 205, 86, 0.2)",
              "rgba(119, 158, 203, 0.2)"
            ],
            borderColor: [
              "rgb(76, 175, 80)",
              "rgb(255, 99, 132)",
              "rgb(255, 205, 86)",
              "rgb(119, 158, 203)"
            ],
            borderWidth: 1
          }
        ]
      },
      showManifest: false,
      manifest: { name: "appname", package: "com.exmaple.appname" },
      pathChecked: [this.manifest],
      polling: null,
      search: "",
      logs: [],
      headers: [
        { text: "Datetime", value: "datetime" },
        { text: "Category", value: "pattern_category" },
        { text: "Pattern", value: "pattern_title", sortable: false },
        { text: "Caller", value: "caller", sortable: false },
        { text: "Payload", value: "payload_abb", sortable: false }
      ],
      since: 0
    };
  },
  computed: {
    getAppName() {
      return this.manifest?.name;
    },
    getPackageName() {
      return this.manifest?.package;
    },
    logdata() {
      // remove dup
      let _ = new Set(this.logs);
      this.logs = [..._];

      return this.logs.map(_ => {
        _.data.datetime = new Date(_.create_at * 1000)
          .toISOString()
          .substr(11, 19);
        _.data.payload_abb = _.data.payload.substr(0, 35);
        if (_?.pattern !== null) {
          _.data.pattern_category = _.pattern.category;
          _.data.pattern_title = _.pattern.title;
        } else {
          _.data.pattern_category = _.data.pattern_title = null;
        }
        return _.data;
      });
    }
  },
  created() {
    this.getManifest(localStorage.getItem('app_digest'));
    this.getLogPeriodically();
  },
  methods: {
    refreshChart() {
      let _ = { DISCOVERY: 0, ATTACK: 0, HIDING: 0, NETWORK: 0 };
      this.logs.map(log => {
        _[log?.pattern?.category] += 1;
      });
      this.chartData.datasets[0].total = [
        _.DISCOVERY,
        _.ATTACK,
        _.HIDING,
        _.NETWORK
      ].reduce((a, b) => a + b, 0);
      this.chartData.datasets[0].data = [_.DISCOVERY, _.ATTACK, _.HIDING, _.NETWORK];
    },
    getManifest(target) {
      manifest.getManifest(target).then(res => {
        this.manifest = res.data.app_default_info;
      });
    },
    getLog(session_id, since = 0) {
      let log = [];
      this.refreshChart();
      logcat.parseLogcat(session_id, since).then(res => {
        for (log of res.data) {
          try {
            this.logs.push(log);
            if (this.since < log.create_at) this.since = log.create_at;
          } catch (error) {
            console.log(error);
          }
        }
      });
    },
    getColor(pattern) {
      if (pattern === "DISCOVERY") return "green";
      else if (pattern === "ATTACK") return "red";
      else if (pattern === "HIDING") return "gray";
      else if (pattern === "NETWORK") return "blue"
    },
    getLogPeriodically() {
      this.polling = setInterval(() => {
        this.getLog(localStorage.getItem('session_id'), this.since);
      }, 2500); // 2.5s interval
    },
    stopAnalyze() {
      let session_id = localStorage.getItem('session_id');
      if (session_id === undefined) {
        alert("[-] session_id is not given or wrong");
        return;
      }
      session.stopApp(session_id).then(() => {
        window.clearInterval(this.polling);
        Util.sleep(5000).then(()=>{
          console.log("[+] the app is stopped");
          this.$router.push("/select_target");
        })
      });
    }
  },
  destroyed() {
    window.clearInterval(this.polling);
  }
};
</script>

<style lang="sass" scoped>
.device-info-text
  font-size: 15px
  letter-spacing: 0px
  line-height: 35px
</style>
